#include<Trade\Trade.mqh>
#include<patterns_library.mqh>

CTrade trade;

input int pattern_by = 0;
input int pattern_bn = 21;
input int pattern_sy = 0;
input int pattern_sn = 21;
input int sl_short = 300;
input int tp_short = 600;
input int sl_long = 300;
input int tp_long = 600;
double ask, bid;
double highd[], lowd[];
MqlRates daily[];

void OnTick(){
   ask = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
   bid = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);

   MqlRates current[];
   ArraySetAsSeries(daily,true);
   ArraySetAsSeries(current,true);
   ArraySetAsSeries(highd,true);
   ArraySetAsSeries(lowd,true);
   int daily_data = CopyRates(_Symbol,PERIOD_D1,0,6,daily);
   int current_data = CopyRates(_Symbol,_Period,0,3,current);
   CopyHigh(_Symbol,PERIOD_D1,0,6,highd);
   CopyLow(_Symbol,PERIOD_D1,0,6,lowd);

   int bar_period = Bars(_Symbol,_Period);
   int bar_daily = Bars(_Symbol,PERIOD_D1);

   if(PositionsTotal() == 0 && new_period_bar(bar_period)){
      if(pattern(pattern_by) && pattern(pattern_bn) == false && current[0].open < daily[ArrayMaximum(highd,1,1)].high && current[1].open > daily[ArrayMaximum(highd,1,1)].high && current[2].open < daily[ArrayMaximum(highd,1,1)].high){
         trade.Sell(0.01,NULL,bid,bid + sl_short * _Point,bid - tp_short * _Point,NULL);
         //trade.Buy(0.01,NULL,ask,ask - sl_long * _Point,ask+tp_long*_Point,NULL);
      }
      if(pattern(pattern_sy) && pattern(pattern_sn) == false && current[0].open > daily[ArrayMinimum(lowd,1,1)].low && current[1].open < daily[ArrayMinimum(lowd,1,1)].low && current[2].open > daily[ArrayMinimum(lowd,1,1)].low){
         trade.Buy(0.01,NULL,ask,ask - sl_long * _Point,ask + tp_long * _Point,NULL);
         //trade.Sell(0.01,NULL,bid,bid + sl_short * _Point, bid - tp_short * _Point,NULL);

      }
   }
   //if(new_daily_bar(bar_daily)){
   //   close_all_pos();
   //}
}


//Later migrated helper functions in library utility

bool new_period_bar(int CandleNumber){
   static int last_period_number;
   bool value = false;
   if(CandleNumber > last_period_number){
      value = true;
      last_period_number = CandleNumber;
   }
   return value;
}

bool new_daily_bar(int DailyNumber){
   static int last_daily_number;
   bool value = false;
   if(DailyNumber > last_daily_number){
      value = true;
      last_daily_number = DailyNumber;
   }
   return value;
}

void close_all_pos(){
   for(int i = PositionsTotal()-1; i>=0; i--){
      ulong ticket=PositionGetTicket(i);
      trade.PositionClose(ticket);
   }
}